#include<iostream>
#include<fstream>
#include<cstdlib>
using std::cout;
using std::cin;
using std::endl;
using std::fstream;
using std::ofstream;
using std::ifstream;
using std::ios;
class account_query
{
private:
    char account_number[20];
    char firstName[10];
    char lastName[10];
    float total_Balance;
public:
    void read_data();
    void show_data();
    void write_rec();
    void read_rec();
    void search_rec();
    void edit_rec();
    void delete_rec();
};
void account_query::read_data()
{
	system("cls");
    cout<<"\nEnter Account Number: ";
    cin>>account_number;
    cout<<"-------------------------";
    cout<<"\nEnter First Name: ";
    cin>>firstName;
    cout<<"-------------------------";
    cout<<"\nEnter Last Name: ";
    cin>>lastName;
    cout<<"-------------------------";
    cout<<"\nEnter Balance: ";
    cin>>total_Balance;
    cout<<"-------------------------";
    cout<<endl;
    cout<<"\n Account Details Saved!!\n\n";
    system("PAUSE");
   
}
void account_query::show_data()
{
	system("cls");
	cout<<" : ACCOUNT DETAILS : ";
    cout<<"\n\nAccount Number: "<<account_number<<endl;
    cout<<"-------------------------";
    cout<<"\nFirst Name: "<<firstName<<endl;
    cout<<"-------------------------";
    cout<<"\nLast Name: "<<lastName<<endl;
    cout<<"-------------------------";
    cout<<"\nCurrent Balance: Rs.  "<<total_Balance<<endl;
    cout<<"-------------------------------"<<endl;
    system("PAUSE");
    
}
void account_query::write_rec()
{
    ofstream outfile;
    outfile.open("record.bank", ios::binary|ios::app);
    read_data();
    outfile.write(reinterpret_cast<char *>(this), sizeof(*this));
    outfile.close();
}
void account_query::read_rec()
{
	system("cls");
    ifstream infile;
    infile.open("record.bank", ios::binary);
    if(!infile)
    {
        cout<<"Error in Opening! File Not Found!!"<<endl;
        return;
    }
    cout<<"\n****Data from file****"<<endl;
    while(!infile.eof())
    {
        if(infile.read(reinterpret_cast<char*>(this), sizeof(*this))>0)
        {
            show_data();
        }
    }
    infile.close();
    system("PAUSE");
}
void account_query::search_rec()
{
	system("cls");
    int n;
    ifstream infile;
    infile.open("record.bank", ios::binary);
    if(!infile)
    {
        cout<<"\nError in opening! File Not Found!!"<<endl;
        return;
    }
    infile.seekg(0,ios::end);
    int count = infile.tellg()/sizeof(*this);
    cout<<"\n There are "<<count<<" record in the file";
    cout<<"\n--------------------------------";
    cout<<"\n Enter Record Number to Search: ";
    cin>>n;
    infile.seekg((n-1)*sizeof(*this));
    infile.read(reinterpret_cast<char*>(this), sizeof(*this));
    show_data();
    system("PAUSE");
}
void account_query::edit_rec()
{
	system("cls");
    int n;
    fstream iofile;
    iofile.open("record.bank", ios::in|ios::binary);
    if(!iofile)
    {
        cout<<"\nError in opening! File Not Found!!"<<endl;
        return;
    }
    iofile.seekg(0, ios::end);
    int count = iofile.tellg()/sizeof(*this);
    cout<<"\n There are "<<count<<" record in the file";
    cout<<"\n Enter Record Number to edit: ";
    cin>>n;
    iofile.seekg((n-1)*sizeof(*this));
    iofile.read(reinterpret_cast<char*>(this), sizeof(*this));
    cout<<"Record "<<n<<" has following data"<<endl;
    show_data();
    iofile.close();
    iofile.open("record.bank", ios::out|ios::in|ios::binary);
    iofile.seekp((n-1)*sizeof(*this));
    cout<<"\nEnter data to Modify "<<endl;
    read_data();
    iofile.write(reinterpret_cast<char*>(this), sizeof(*this));
    system("PAUSE");
}
void account_query::delete_rec()
{
	system("cls");
    int n;
    ifstream infile;
    infile.open("record.bank", ios::binary);
    if(!infile)
    {
        cout<<"\nError in opening! File Not Found!!"<<endl;
        return;
    }
    infile.seekg(0,ios::end);
    int count = infile.tellg()/sizeof(*this);
    cout<<"\n There are "<<count<<" record in the file";
    cout<<"\n Enter Record Number to Delete: ";
    cin>>n;
    fstream tmpfile;
    tmpfile.open("tmpfile.bank", ios::out|ios::binary);
    infile.seekg(0);
    for(int i=0; i<count; i++)
    {
        infile.read(reinterpret_cast<char*>(this),sizeof(*this));
        if(i==(n-1))
            continue;
        tmpfile.write(reinterpret_cast<char*>(this), sizeof(*this));
    }
    infile.close();
    tmpfile.close();
    remove("record.bank");
    rename("tmpfile.bank", "record.bank");
    system("PAUSE");
}
int main()
{
	
	system("cls");
    account_query A;
    int choice;
    cout<<"\n  *****Account Information System*****"<<endl;
    while(true)
    {
    	system("cls");
    	cout<<"\n  *****Account Information System*****"<<endl;
        cout<<"\t\nSelect Any Option Below \n";
        cout<<"\n\t-------------------------";
        cout<<"\n\t1>> Add record to file";
        cout<<"\n\t-------------------------";
        cout<<"\n\t2>> Show record from file";
        cout<<"\n\t-------------------------";
        cout<<"\n\t3>> Search Record from file";
        cout<<"\n\t-------------------------";
        cout<<"\n\t4>> Update Record";
        cout<<"\n\t-------------------------";
        cout<<"\n\t5>> Delete Record";
        cout<<"\n\t-------------------------";
        cout<<"\n\t6>> Quit";
        cout<<"\n\t-------------------------";
        cout<<"\n\nEnter your choice: ";
        cin>>choice;
        

   
        switch(choice)
        {
        case 1:
            A.write_rec();
            break;
        case 2:
            A.read_rec();
            break;
            
        case 3:
            A.search_rec();
            break;
        case 4:
            A.edit_rec();
            break;
        case 5:
            A.delete_rec();
            break;
        case 6:
            exit(0);
            break;
        default:
            cout<<"\nEnter corret choice";
            exit(0);
        }
    }
    system("pause");
    return 0;
}


